/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com). 
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef LIBENATSC3IPV4_H
#define LIBENATSC3IPV4_H

typedef struct _ENATSC3IPV4Handle_t *ENATSC3IPV4Handle_t;

typedef void (*ENATSC3IPV4TransportPacketCallbackFunction)(
    int32_t plpid, struct timespec *pPacketTimeUTC, uint64_t packetNumber, 
    uint32_t sourceAddress, uint32_t destinationAddress, uint16_t protocol, 
    const uint8_t *pPacket, int32_t sPacket, void *pUserData);

ENStatus
ENATSC3IPV4Open(ENATSC3IPV4Handle_t *phATSC3IPV4);

ENStatus
ENATSC3IPV4Close(ENATSC3IPV4Handle_t hATSC3IPV4);

void
ENATSC3IPV4SetVerbosity(ENATSC3IPV4Handle_t hATSC3IPV4, ENVerbosity verbosity);

ENStatus
ENATSC3IPV4RegisterCallbacks(ENATSC3IPV4Handle_t hATSC3IPV4,
    ENATSC3IPV4TransportPacketCallbackFunction pTransportPacketCallback,
    void *pUserData);

ENStatus
ENATSC3IPV4ProcessIPV4Packet(ENATSC3IPV4Handle_t hATSC3IPV4,
    int32_t plpId, struct timespec *pPacketTimeUTC, uint64_t packetNumber, 
    const uint8_t *pPayload, int32_t payloadLength);

#endif
