/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com). 
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3ROUTE_SLS_METADATA_ENVELOPE_H
#define ENATSC3ROUTE_SLS_METADATA_ENVELOPE_H

typedef struct
{
    EnXMLParserNodeBase base;

    int32_t metadataURIDataOffset;
    uint32_t version;
    int32_t contentTypeDataOffset;
} ENATSC3ROUTESLSEnvelopeItemNode;

#define ENATSC3ROUTESLSEnvelopeItemNodeAttribute_metadataURI   0x0001
#define ENATSC3ROUTESLSEnvelopeItemNodeAttribute_version       0x0002
#define ENATSC3ROUTESLSEnvelopeItemNodeAttribute_contentType   0x0004

typedef struct
{
    EnXMLParserNodeBase base;

    EnXMLParserDataOffsetArray items;           // Array of 
                                                // ENATSC3ROUTESLSEnvelopeItemNode
    int32_t nItems;

    EnXMLParserDataBuffer dataBuffer;
} ENATSC3ROUTESLSEnvelopeNode;

#define ENATSC3ROUTESLSEnvelopeNodeAttribute_XMLNS             0x0001
#define ENATSC3ROUTESLSEnvelopeChildNode_item                  0x0002

typedef enum
{
    ENATSC3ROUTESLSEnvelopeNodeType_Invalid = 0,
    ENATSC3ROUTESLSEnvelopeNodeType_metadataEnvelope = 1,
    ENATSC3ROUTESLSEnvelopeNodeType_item = 2,
} ENATSC3ROUTESLSEnvelopeNodeType;

ENStatus
ENATSC3ROUTESLSEnvelopeParse(const char *pXML, int32_t sXML,
    ENATSC3ROUTESLSEnvelopeNode *pParsedEnvelope);

ENStatus
ENATSC3ROUTESLSEnvelopeFree(ENATSC3ROUTESLSEnvelopeNode *pParsedEnvelope);

#endif
